]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - scripts/zloop.sh
Force ztest to always use /dev/urandom
[FreeBSD/FreeBSD.git] / scripts / zloop.sh
1 #!/bin/bash
2
3 #
4 # CDDL HEADER START
5 #
6 # This file and its contents are supplied under the terms of the
7 # Common Development and Distribution License ("CDDL"), version 1.0.
8 # You may only use this file in accordance with the terms of version
9 # 1.0 of the CDDL.
10 #
11 # A full copy of the text of the CDDL should have accompanied this
12 # source.  A copy of the CDDL is also available via the Internet at
13 # http://www.illumos.org/license/CDDL.
14 #
15 # CDDL HEADER END
16 #
17
18 #
19 # Copyright (c) 2015 by Delphix. All rights reserved.
20 # Copyright (C) 2016 Lawrence Livermore National Security, LLC.
21 #
22
23 BASE_DIR=$(dirname "$0")
24 SCRIPT_COMMON=common.sh
25 if [ -f "${BASE_DIR}/${SCRIPT_COMMON}" ]; then
26         . "${BASE_DIR}/${SCRIPT_COMMON}"
27 else
28         echo "Missing helper script ${SCRIPT_COMMON}" && exit 1
29 fi
30
31 # shellcheck disable=SC2034
32 PROG=zloop.sh
33 GDB=${GDB:-gdb}
34
35 DEFAULTWORKDIR=/var/tmp
36 DEFAULTCOREDIR=/var/tmp/zloop
37
38 function usage
39 {
40         echo -e "\n$0 [-t <timeout>] [ -s <vdev size> ] [-c <dump directory>]" \
41             "[ -- [extra ztest parameters]]\n" \
42             "\n" \
43             "  This script runs ztest repeatedly with randomized arguments.\n" \
44             "  If a crash is encountered, the ztest logs, any associated\n" \
45             "  vdev files, and core file (if one exists) are moved to the\n" \
46             "  output directory ($DEFAULTCOREDIR by default). Any options\n" \
47             "  after the -- end-of-options marker will be passed to ztest.\n" \
48             "\n" \
49             "  Options:\n" \
50             "    -t  Total time to loop for, in seconds. If not provided,\n" \
51             "        zloop runs forever.\n" \
52             "    -s  Size of vdev devices.\n" \
53             "    -f  Specify working directory for ztest vdev files.\n" \
54             "    -c  Specify a core dump directory to use.\n" \
55             "    -h  Print this help message.\n" \
56             "" >&2
57 }
58
59 function or_die
60 {
61         # shellcheck disable=SC2068
62         $@
63         # shellcheck disable=SC2181
64         if [[ $? -ne 0 ]]; then
65                 # shellcheck disable=SC2145
66                 echo "Command failed: $@"
67                 exit 1
68         fi
69 }
70
71 # core file helpers
72 origcorepattern="$(cat /proc/sys/kernel/core_pattern)"
73 coreglob="$(egrep -o '^([^|%[:space:]]*)' /proc/sys/kernel/core_pattern)*"
74
75 if [[ $coreglob = "*" ]]; then
76         echo "Setting core file pattern..."
77         echo "core" > /proc/sys/kernel/core_pattern
78         coreglob="$(egrep -o '^([^|%[:space:]]*)' \
79             /proc/sys/kernel/core_pattern)*"
80 fi
81
82 function core_file
83 {
84         # shellcheck disable=SC2012 disable=2086
85         printf "%s" "$(ls -tr1 $coreglob 2> /dev/null | head -1)"
86 }
87
88 function core_prog
89 {
90         prog=$ZTEST
91         core_id=$($GDB --batch -c "$1" | grep "Core was generated by" | \
92             tr  \' ' ')
93         # shellcheck disable=SC2076
94         if [[ "$core_id" =~ "zdb "  ]]; then
95                 prog=$ZDB
96         fi
97         printf "%s" "$prog"
98 }
99
100 function store_core
101 {
102         core="$(core_file)"
103         if [[ $ztrc -ne 0 ]] || [[ -f "$core" ]]; then
104                 df -h "$workdir" >>ztest.out
105                 coreid=$(date "+zloop-%y%m%d-%H%M%S")
106                 foundcrashes=$((foundcrashes + 1))
107
108                 dest=$coredir/$coreid
109                 or_die mkdir -p "$dest"
110                 or_die mkdir -p "$dest/vdev"
111
112                 echo "*** ztest crash found - moving logs to $dest"
113
114                 or_die mv ztest.history "$dest/"
115                 or_die mv ztest.ddt "$dest/"
116                 or_die mv ztest.out "$dest/"
117                 or_die mv "$workdir/ztest*" "$dest/vdev/"
118                 or_die mv "$workdir/zpool.cache" "$dest/vdev/"
119
120                 # check for core
121                 if [[ -f "$core" ]]; then
122                         coreprog=$(core_prog "$core")
123                         corestatus=$($GDB --batch --quiet \
124                             -ex "set print thread-events off" \
125                             -ex "printf \"*\n* Backtrace \n*\n\"" \
126                             -ex "bt" \
127                             -ex "printf \"*\n* Libraries \n*\n\"" \
128                             -ex "info sharedlib" \
129                             -ex "printf \"*\n* Threads (full) \n*\n\"" \
130                             -ex "info threads" \
131                             -ex "printf \"*\n* Backtraces \n*\n\"" \
132                             -ex "thread apply all bt" \
133                             -ex "printf \"*\n* Backtraces (full) \n*\n\"" \
134                             -ex "thread apply all bt full" \
135                             -ex "quit" "$coreprog" "$core" | grep -v "New LWP")
136
137                         # Dump core + logs to stored directory
138                         echo "$corestatus" >>"$dest/status"
139                         or_die mv "$core" "$dest/"
140
141                         # Record info in cores logfile
142                         echo "*** core @ $coredir/$coreid/$core:" | \
143                             tee -a ztest.cores
144                         echo "$corestatus" | tee -a ztest.cores
145                         echo "" | tee -a ztest.cores
146                 fi
147                 echo "continuing..."
148         fi
149 }
150
151 # parse arguments
152 # expected format: zloop [-t timeout] [-c coredir] [-- extra ztest args]
153 coredir=$DEFAULTCOREDIR
154 basedir=$DEFAULTWORKDIR
155 rundir="zloop-run"
156 timeout=0
157 size="512m"
158 while getopts ":ht:s:c:f:" opt; do
159         case $opt in
160                 t ) [[ $OPTARG -gt 0 ]] && timeout=$OPTARG ;;
161                 s ) [[ $OPTARG ]] && size=$OPTARG ;;
162                 c ) [[ $OPTARG ]] && coredir=$OPTARG ;;
163                 f ) [[ $OPTARG ]] && basedir=$(readlink -f "$OPTARG") ;;
164                 h ) usage
165                     exit 2
166                     ;;
167                 * ) echo "Invalid argument: -$OPTARG";
168                     usage
169                     exit 1
170         esac
171 done
172 # pass remaining arguments on to ztest
173 shift $((OPTIND - 1))
174
175 # enable core dumps
176 ulimit -c unlimited
177 export ASAN_OPTIONS=abort_on_error=1:disable_coredump=0
178
179 if [[ -f "$(core_file)" ]]; then
180         echo -n "There's a core dump here you might want to look at first... "
181         core_file
182         exit 1
183 fi
184
185 if [[ ! -d $coredir ]]; then
186         echo "core dump directory ($coredir) does not exist, creating it."
187         or_die mkdir -p "$coredir"
188 fi
189
190 if [[ ! -w $coredir ]]; then
191         echo "core dump directory ($coredir) is not writable."
192         exit 1
193 fi
194
195 or_die rm -f ztest.history
196 or_die rm -f ztest.ddt
197 or_die rm -f ztest.cores
198
199 ztrc=0          # ztest return value
200 foundcrashes=0  # number of crashes found so far
201 starttime=$(date +%s)
202 curtime=$starttime
203
204 # if no timeout was specified, loop forever.
205 while [[ $timeout -eq 0 ]] || [[ $curtime -le $((starttime + timeout)) ]]; do
206         zopt="-VVVVV"
207
208         # start each run with an empty directory
209         workdir="$basedir/$rundir"
210         or_die rm -rf "$workdir"
211         or_die mkdir "$workdir"
212
213         # switch between common arrangements & fully randomized
214         if [[ $((RANDOM % 2)) -eq 0 ]]; then
215                 mirrors=2
216                 raidz=0
217                 parity=1
218                 vdevs=2
219         else
220                 mirrors=$(((RANDOM % 3) * 1))
221                 parity=$(((RANDOM % 3) + 1))
222                 raidz=$((((RANDOM % 9) + parity + 1) * (RANDOM % 2)))
223                 vdevs=$(((RANDOM % 3) + 3))
224         fi
225         align=$(((RANDOM % 2) * 3 + 9))
226         runtime=$((RANDOM % 100))
227         passtime=$((RANDOM % (runtime / 3 + 1) + 10))
228
229         zopt="$zopt -m $mirrors"
230         zopt="$zopt -r $raidz"
231         zopt="$zopt -R $parity"
232         zopt="$zopt -v $vdevs"
233         zopt="$zopt -a $align"
234         zopt="$zopt -T $runtime"
235         zopt="$zopt -P $passtime"
236         zopt="$zopt -s $size"
237         zopt="$zopt -f $workdir"
238
239         # shellcheck disable=SC2124
240         cmd="$ZTEST $zopt $@"
241         desc="$(date '+%m/%d %T') $cmd"
242         echo "$desc" | tee -a ztest.history
243         echo "$desc" >>ztest.out
244         $cmd >>ztest.out 2>&1
245         ztrc=$?
246         egrep '===|WARNING' ztest.out >>ztest.history
247         $ZDB -U "$workdir/zpool.cache" -DD ztest >>ztest.ddt 2>&1
248
249         store_core
250
251         curtime=$(date +%s)
252 done
253
254 echo "zloop finished, $foundcrashes crashes found"
255
256 #restore core pattern
257 echo "$origcorepattern" > /proc/sys/kernel/core_pattern
258
259 uptime >>ztest.out
260
261 if [[ $foundcrashes -gt 0 ]]; then
262         exit 1
263 fi